/**
* Based on a shader from Wagner Effects Composer for Three.JS
* https://github.com/spite/Wagner
*/
#ifdef GL_FRAGMENT_PRECISION_HIGH
	precision highp float;
#else
	precision mediump float;
#endif

uniform float brightness;
uniform float contrast;
uniform float gamma;
uniform sampler2D tInput;

varying highp vec2 vUv;

void main(void) {
	vec3 color = texture2D(tInput, vUv).rgb;
	
	vec3 colorContrasted = (color) * contrast;
	vec3 bright = colorContrasted + vec3(brightness, brightness, brightness);
	vec3 final = pow(bright, vec3(1. / gamma));

	gl_FragColor.rgb = final;
	gl_FragColor.a = 1.;
}